//
// PC-8001 USB CRT G~[^ for Windows
//
//             copyleft 2009 Koichi Nishida
//            on Gnu General Public License
//

#include <windows.h>
#include <tchar.h>
#include "stdafx.h"
#include "ftd2xx.h"
#include "resource.h"

// USB ̍őobt@TCY
#define MAX_BUFSIZE 256

// EBhẼ^Cg̍
#define TITLE_HEIGHT (GetSystemMetrics(SM_CYCAPTION)+GetSystemMetrics(SM_CYMENU))

#define WINDOW_X 100				//EBhËʒu
#define WINDOW_Y 100

// ^C}[
#define TIMER_ID     (100)			// ^C}[ID
#define TIMER_ELAPSE (1000/60)		// WM_TIMER̔Ԋu

// CX^X
HINSTANCE hinst;

// EBhE
HWND hwnd;

// USB ̃obt@TCY
int Bufsize = 32;

// ROW oCg
int RowBytes = 416;

// C
int Lines = 262;

// Ch[h
int Wide = 1;

// USB nh
FT_HANDLE ftHandle;

// DIBpϐ
BITMAPINFO g_biDIB;
LPDWORD g_lppxDIB = NULL;

// t[obt@
BYTE* g_picbuf;

// vg^Cv錾
HWND CreateWin(HINSTANCE hInst);
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp);
BOOL CALLBACK DlgProc(HWND hDlg, UINT mst, WPARAM wp, LPARAM lp);
int InitUSB();
void TrashUSB();
int GetUSB(BYTE *);
bool MakeIniFileName(char *ini_fname, char *ini_fullpath);

// DIBpăAP[g
void reallocDIB()
{
	if (g_lppxDIB) HeapFree(GetProcessHeap(), 0, g_lppxDIB);

	// DIBpBITMAPINFONA
	ZeroMemory(&g_biDIB, sizeof(g_biDIB));

	// DIBpBITMAPINFOݒ
	g_biDIB.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	g_biDIB.bmiHeader.biWidth = RowBytes*(Wide+1);
	g_biDIB.bmiHeader.biHeight = Lines*(Wide+1);
	g_biDIB.bmiHeader.biPlanes = 1;
	g_biDIB.bmiHeader.biBitCount = 32;
	g_biDIB.bmiHeader.biCompression = BI_RGB;

	// DIBpsNZm
	g_lppxDIB = (LPDWORD)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
		RowBytes*(Wide+1) * Lines*(Wide+1) * 4);
}

// C
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int showCmd)
{
	MSG msg;
	char ini_fname[256];

	hinst = hInst;

	// ini t@Cݒǂ
	if (MakeIniFileName("P8USBCRT.ini", ini_fname)) {
		int value;
	    value = GetPrivateProfileInt("section", "wide", -1, ini_fname);
		if (value != -1) Wide = value;
	    value = GetPrivateProfileInt("section", "bufsize", -1, ini_fname);
		if (value != -1) Bufsize = value;
		 value = GetPrivateProfileInt("section", "rowbytes", -1, ini_fname);
		if (value != -1) RowBytes = value;
		 value = GetPrivateProfileInt("section", "lines", -1, ini_fname);
		if (value != -1) Lines = value;
	}

	// USB 
	if (InitUSB()) {
		MessageBox(NULL, _T("USB ̏Ɏs܂"), _T("G["), MB_OK);
		return 1;
	}

	// t[obt@m
	g_picbuf = (BYTE *)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 0x20000);

	reallocDIB();

	// EBhE쐬
	hwnd = CreateWin(hInst);
	if(hwnd == NULL)
	{
		MessageBox(NULL, _T("EBhE̍쐬Ɏs܂"), _T("G["), MB_OK);
		return 1;
	}

	// EBhE\
	ShowWindow(hwnd, SW_SHOW);
	UpdateWindow(hwnd);

	// ^C}쐬
	SetTimer(hwnd, TIMER_ID, TIMER_ELAPSE, NULL);

	// bZ[W[v
	while (1) {
		BOOL ret = GetMessage(&msg, NULL, 0, 0);  // bZ[W擾
		if (ret == 0 || ret == -1)
		{
			// AvP[VIbZ[WĂA
			// 邢 GetMessage() s
			break;
		}
		else
		{
			// bZ[W
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	// ^C}j
	KillTimer(hwnd, TIMER_ID);

	// USB 
	TrashUSB();

	// J
	HeapFree(GetProcessHeap(), 0, g_lppxDIB);
	HeapFree(GetProcessHeap(), 0, g_picbuf);

	// ini t@Cɐݒ
	if (MakeIniFileName("P8USBCRT.ini", ini_fname)) {
		char cstr[10];
		wsprintf((LPSTR)cstr, _T("%d"), Wide);
		WritePrivateProfileString( "section", "wide", cstr, ini_fname);
		wsprintf((LPSTR)cstr, _T("%d"), Bufsize);
		WritePrivateProfileString( "section", "bufsize", cstr, ini_fname);
		wsprintf((LPSTR)cstr, _T("%d"), RowBytes);
		WritePrivateProfileString( "section", "rowbytes", cstr, ini_fname);
		wsprintf((LPSTR)cstr, _T("%d"), Lines);
		WritePrivateProfileString( "section", "lines", cstr, ini_fname);
	}
	return 0;
}

// EBhE쐬
HWND CreateWin(HINSTANCE hInst)
{
	WNDCLASSEX wc;

	// EBhENX̏ݒ
	wc.cbSize = sizeof(wc);					// \̃TCY
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;	// X^C
	wc.lpfnWndProc = WndProc;				// EBhEvV[W
	wc.cbClsExtra = 0;						// gP
	wc.cbWndExtra = 0;						// gQ
	wc.hInstance = hInst;					// CX^Xnh
	wc.hIcon = (HICON)LoadImage(			// ACR
		NULL, MAKEINTRESOURCE(IDI_APPLICATION), IMAGE_ICON,
		0, 0, LR_DEFAULTSIZE | LR_SHARED
	);
	wc.hIconSm = wc.hIcon;					// qACR
	wc.hCursor = (HCURSOR)LoadImage(		// }EXJ[\
		NULL, MAKEINTRESOURCE(IDC_ARROW), IMAGE_CURSOR,
		0, 0, LR_DEFAULTSIZE | LR_SHARED
	);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH); // EBhEwi
	wc.lpszMenuName = NULL;					// j[
	wc.lpszClassName = _T("P8USBCRT");		// EBhENX
	
	// EBhENXo^
	if( RegisterClassEx( &wc ) == 0 ){ return NULL; }

	// EBhE쐬
	return CreateWindow(
		wc.lpszClassName,		// EBhENX
		_T("P8USBCRT"),			// ^Cgo[ɕ\镶
		WS_OVERLAPPEDWINDOW & ~WS_THICKFRAME & ~WS_MAXIMIZEBOX,   // EBhE̎
		WINDOW_X,				// EBhE\ʒuiXWj
		WINDOW_Y,				// EBhE\ʒuiYWj
		RowBytes*(Wide+1),		// EBhE̕
		Lines*(Wide+1) + TITLE_HEIGHT, // EBhE̍
		NULL,					// eEBhẼEBhEnh
		NULL,					// j[nh
		hInst,					// CX^Xnh
		NULL					// ̑̍쐬f[^
	);
}

// Window TCY
void ResizeWin()
{
	int cx = RowBytes*(Wide+1), cy = Lines*(Wide+1) + TITLE_HEIGHT;
	SetWindowPos(hwnd, NULL, 0, 0, cx, cy, SWP_NOMOVE);
}

// EBhEvV[W
LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	HDC hdc;
	PAINTSTRUCT ps;
	unsigned char prev, dt = 0, length, val;
	static int bytes = 0;			// 10 t[̃oCg 
	static int tcount = 0;			// ^CgXVpJE^
	static int tick = 0;			// t[XV tick 
	int i, x, y, ipic, adr;
	LPDWORD p, q, r;
	static HMENU hmenu;				// j[

	switch (msg) {
	case WM_CREATE:
		hmenu = LoadMenu(NULL, _T("IDR_MENU"));
		SetMenu(hwnd, hmenu);
		CheckMenuItem(hmenu, ID_WIDE, Wide ? MF_CHECKED : MF_UNCHECKED);
		DrawMenuBar(hwnd);
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wp)) {
		case ID_EXIT:
			DestroyWindow(hwnd);
			break;
		case ID_WIDE: {
			Wide = !Wide;
			CheckMenuItem(hmenu, ID_WIDE, Wide ? MF_CHECKED : MF_UNCHECKED);
			DrawMenuBar(hwnd);
			ResizeWin();
			return 0;
		}
		case ID_PREF: {
			DialogBox(hinst, "IDR_DIALOG", hwnd, (DLGPROC)DlgProc);
			break;
		}
		}
		break;
	case WM_TIMER:	// ^C}[bZ[W
		if(wp != TIMER_ID)
		{
			break;	// IDvȂ^C}[bZ[WDefWindowProc()
		}
		// wb_҂
		do {
			prev = dt;
			if (GetUSB(&dt)) {
				// USB ĂI
				PostQuitMessage(0);
				return 1;
			}
			bytes++;
		} while (!((prev == 0 || prev == 1) && dt == 0x82));
		// wb_	01 82	Ȃ I sN`
		//			00 82	Ȃ P sN`
		ipic = prev;
RESET:
		dt = 0; val = 0; length = 0; adr = 0;
		p = g_lppxDIB + RowBytes*(Wide+1) * (Lines*(Wide+1)-1);
		for (y = 0; y < Lines; y++) {
			q = p;
			r = q - RowBytes*(Wide+1);
			for (x = 0; x < RowBytes; x++) {
				BYTE R, G, B;
				DWORD pval;
				if (length == 0) {
					// lƒ𓾂
					if (GetUSB(&val)) {
						PostQuitMessage(0);
						return 1;
					}
					if (GetUSB(&length)) {
						PostQuitMessage(0);
						return 1;
					}
					bytes += 2;
					if ((val == 0x01) && (length == 0x82)) { // wb_oBBB
						ipic = 1;
						goto RESET;
					}
				}
				// I sN`ȂAl̂܂܎g
				// P sN`ȂAO̒lɑ
				if (ipic) dt = val;
				else dt = g_picbuf[adr] + val;
				g_picbuf[adr++] = dt;
				length--;
				if (ipic || (val != 0)) {
					// ʏ탂[h
					for (i=0; i<2; i++) {
						R = (dt&0x1)*255;
						G = ((dt>>1)&1)*255;
						B = ((dt>>2)&1)*255;
						pval = ((R << 16) | (G << 8) | B);
						if (Wide || (i==0)) *(p++) = pval;
						if (Wide) *(r++) = pval; 
						dt >>= 4;
					}
				} else {
					p += (Wide ? 2 : 1); r += (Wide ? 2 : 1);
				}
			}
			p = q - (RowBytes*(Wide+1)) * (Wide ? 2 : 1);
		}
		// ^Cg\
		{
			int ticks = GetTickCount()-tick;
			tick = GetTickCount();
			if (++tcount == 10) {
				char cstr[128];
				wsprintf((LPSTR)cstr, _T("P8USBCRT [%d frames/sec] [%d bytes/frame]"), 1000/ticks, bytes/10);
				SetWindowText(hwnd, (LPCSTR)cstr);
				bytes = 0;
				tcount = 0;
			}
		}
		InvalidateRect( hwnd, NULL, FALSE );
		return 0;
	case WM_PAINT: {	// ̈悪Ƃ
			hdc = BeginPaint(hwnd, &ps);
			// DIB`
			SetDIBitsToDevice(hdc, 0, 0, RowBytes*(Wide+1), Lines*(Wide+1), 0, 0, 0,
					Lines*(Wide+1)+TITLE_HEIGHT, g_lppxDIB, &g_biDIB, DIB_RGB_COLORS);
			EndPaint(hwnd, &ps);
		}
		return 0;
	case WM_CLOSE:
		SetMenu(hwnd, NULL);
		hmenu = NULL;
		break;

	case WM_DESTROY:        // EBhEjƂ
		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd, msg, wp, lp);
}

// USB 
int InitUSB()
{
	FT_STATUS ftStatus;
	
	// USB I[v
	ftStatus = FT_OpenEx("P8USBCRT", FT_OPEN_BY_DESCRIPTION, &ftHandle);
	if (ftStatus != FT_OK) return 1;

	// Output mode ݒ
	ftStatus = FT_SetBitMode(ftHandle, 0x00, 0x00);
	if (ftStatus != FT_OK) return 1;
	
	// obt@TCYݒ
	ftStatus = FT_SetUSBParameters(ftHandle, Bufsize, 0);
	if (ftStatus != FT_OK) return 1;

	// Time Out ݒ
	ftStatus = FT_SetTimeouts(ftHandle, 3000, 3000);
	if (ftStatus != FT_OK) return 1;

	return 0;
}

// USB N[Y
void TrashUSB()
{
	FT_Close(ftHandle);
}

// USB f[^𓾂
int GetUSB(BYTE *dt)
{
	static unsigned char buff[MAX_BUFSIZE];
	static unsigned long bytesRead = 0;
	static unsigned int ptr = 0;
	FT_STATUS ftStatus = FT_OK;

	if (ptr == 0) {
		ftStatus = FT_Read(ftHandle, buff, Bufsize, &bytesRead);
		if (bytesRead == 0 || ftStatus != FT_OK) return 1;
	}
	*dt = buff[ptr];
	if (++ptr == bytesRead) ptr = 0;
	return 0;
}

// _CAOpR[obN
BOOL CALLBACK DlgProc(HWND hdlg, UINT msg, WPARAM wp, LPARAM lp)
{
	char cstr[64];
	switch (msg) {
		case WM_INITDIALOG:
			wsprintf((LPSTR)cstr, _T("%d"), Bufsize);
			SetDlgItemText(hdlg, ID_BUFSZ, cstr);
			wsprintf((LPSTR)cstr, _T("%d"), RowBytes);
			SetDlgItemText(hdlg, ID_ROWB, cstr);
			wsprintf((LPSTR)cstr, _T("%d"), Lines);
			SetDlgItemText(hdlg, ID_LINES, cstr);
			{
				HWND hcheck = GetDlgItem(hdlg, ID_WIDE_CHECK);
				SendMessage(hcheck, BM_SETCHECK,(WPARAM)(Wide?BST_CHECKED:BST_UNCHECKED),0);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wp)) {
				case ID_OK:
					if (GetDlgItemText(hdlg, ID_BUFSZ, cstr, 63)) {
						int tmp = atoi(cstr);
						if (0 < tmp && tmp <= MAX_BUFSIZE) {
							Bufsize = tmp;
							// obt@TCYݒ
							// ăI[vȂƑʖڂ݂
							TrashUSB();
							InitUSB();
							FT_SetUSBParameters(ftHandle, Bufsize, 0);
						}	
					}
					if (GetDlgItemText(hdlg, ID_ROWB, cstr, 63)) {
						RowBytes = atoi(cstr);
					}
					if (GetDlgItemText(hdlg, ID_LINES, cstr, 63)) {
						Lines = atoi(cstr);
					}
					{
						HWND hcheck = GetDlgItem(hdlg, ID_WIDE_CHECK);
						Wide = ((int)SendMessage(hcheck, BM_GETCHECK, 0, 0)) == BST_CHECKED ? 1 : 0;
					}
					reallocDIB();
					EndDialog(hdlg, ID_OK);
					ResizeWin();
					return TRUE;
				case ID_CANCEL:
					EndDialog(hdlg, ID_CANCEL);
					return TRUE;
				default:
					return FALSE;
			}
		case WM_CLOSE:
			EndDialog(hdlg, ID_CANCEL);
			return TRUE;
	}
	return FALSE;
}

// INIt@C̕ۑ쐬
bool MakeIniFileName(char *ini_fname, char *ini_fullpath)
{
    char module[_MAX_PATH + 1]; 
    char drive[_MAX_DRIVE]; 
    char dir[_MAX_DIR]; 
    bool bRet = false;

    // EXE݂ŃtpX擾
    if (GetModuleFileName(NULL, module, sizeof(module)) != 0){
        _splitpath(module, drive, dir, NULL, NULL);

        // t@C쐬
        wsprintf(ini_fullpath, "%s%s%s", drive, dir, ini_fname); 
        bRet = true;
    }
    
    return bRet;
}

